<!DOCTYPE html>
<html lang="en">

<head>
  <title>List users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>

  <div class="container">
    <div class="text-center mt-4 mb-3">
      <h2>Danh sách người dùng</h2>
    </div>

    <table id="user-table" class="table table-bordered table-striped table-hover">
      <thead>
        <tr>
          <td>STT</td>
          <td>Username</td>
          <td>First name</td>
          <td>Last name</td>
          <td>Email</td>
          <td>Age</td>
          <td>Role</td>
          <td>Action</td>
        </tr>
      </thead>
      <tbody>

      </tbody>
    </table>
  </div>
  ​
  <script>
    /***
      * TODO: gán data user vào DataTale, render cột STT và mapping được roleId thành roleName
      
      *** Gợi ý cho cột STT ***
      * a) sử dụng phương thức render trong cột STT (định nghĩa ở columnDefs); 
      * b) khai báo 1 biến toàn cục STT và mỗi lần render thì tăng lên 1
      
      * *** Gợi ý cho cột role ***
      * a) sử dụng phương thức render trong cột Role (định nghĩa ở columnDefs); 
      * b) khai báo 1 hàm từ roleId trả về roleName, và đc gọi hàm này trong phương thức render ở trên
    */

    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gJsonUser = `{
      "description": "Data user",
      "users": [
      {
        "id": 2,
        "username": "quannv",
        "firstname": "Ngo Van",
        "lastname": "Quan",
        "age": 18,
        "email": "quan@gmail.com",
        "roleId": 5
      },
      {
        "id": 3,
        "username": "longdh",
        "firstname": "Do Hoang",
        "lastname": "Long",
        "age": 19,
        "email": "long@gmail.com",
        "roleId": 8
      },
      {
        "id": 4,
        "username": "hiendt",
        "firstname": "Do Thi",
        "lastname": "Hien",
        "age": 29,
        "email": "hien@gmail.com",
        "roleId": 11
      },
      {
        "id": 6,
        "username": "lanht",
        "firstname": "Ho Thi",
        "lastname": "Lan",
        "age": 27,
        "email": "lan@gmail.com",
        "roleId": 13
      }
    ]
  }`;
      var gJsonRole = `{
      "description": "User Roles",
      "roles": [
        {
          "roleId": 5,
          "roleName": "Admin" 
        },
        {
          "roleId": 8,
          "roleName": "Manager" 
        },
        {
          "roleId": 11,
          "roleName": "Teacher" 
        },
        {
          "roleId": 13,
          "roleName": "Staff" 
        }
      ]
    }`;

      var gObjectJsonUser = JSON.parse(gJsonUser);
      var gObjectJsonRole = JSON.parse(gJsonRole);
      var gUserName = ["id", "username", "firstname", "lastname", "email", "age", "roleId", "action"]; //gán với tên các cột của array
      var gSTT_COL = 0;
      var gUSERNAME_COL = 1;
      var gFIRSTNAME_COL = 2;
      var gLASTNAME_COL = 3;
      var gEMAIL_COL = 4;
      var gAGE_COL = 5;
      var gROLE_COL = 6;
      var gACTION_COL = 7;
      var gStt = 0;
      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();
      loadDataToTable(gObjectJsonUser);
      $("#user-table").on("click", ".btn-detail", function () {
        onBtnDetailClick(this);
      })
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onPageLoading() {
        //add JSON dât vào DataTable sử dụng add trực tiếp DataTable row
        $("#user-table").DataTable({
          columns: [
            { data: gUserName[gSTT_COL] },
            { data: gUserName[gUSERNAME_COL] },
            { data: gUserName[gFIRSTNAME_COL] },
            { data: gUserName[gLASTNAME_COL] },
            { data: gUserName[gEMAIL_COL] },
            { data: gUserName[gAGE_COL] },
            { data: gUserName[gROLE_COL] },
            { data: gUserName[gACTION_COL] },
          ],
          columnDefs: [
            {
              targets: gSTT_COL, // Cột số thứ tự
              className: "text-primary",
              render: renderStt
            },
            {
              targets: gROLE_COL, //cột role
              className: "text-primary",
              render: renderRoleIdToRoleName,
            },
            {
              targets: gACTION_COL,
              defaultContent: "<button class='btn btn-primary btn-detail'>Chi tiết </button>"
            }
          ]
        });
      }
      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      // Đổ dữ liệu vào datatable thông qua phương thức rows.add()
      function loadDataToTable(paramObjectJsonUser) {
        "use strict";
        var vTable = $("#user-table").DataTable();
        vTable.rows.add(paramObjectJsonUser.users);
        vTable.draw();
      }

      //hàm render số thứ tự
      function renderStt() {
        gStt++;
        return gStt;
      }

      //hàm render từ RoleId sang RoleName
      function renderRoleIdToRoleName(paramRoleId) {
        "use strict";
        var vRoleName = "CHUA_CO_TEN";
        var vFound = false;
        var vViTriHienTai = 0;
        while (!vFound && vViTriHienTai < gObjectJsonRole.roles.length) {
          if (gObjectJsonRole.roles[vViTriHienTai].roleId === paramRoleId) {
            vRoleName = gObjectJsonRole.roles[vViTriHienTai].roleName;
            vFound = true;
          }
          vViTriHienTai++;
        }
        return vRoleName;
      }
      //hàm xử lý khi click nút chi tiết
      function onBtnDetailClick(paramBtnElement) {
        "use strict";
        var vRowSelected = $(paramBtnElement).closest("tr"); // xác định tr chứa nút báma được click
        var vTable = $("#user-table").DataTable(); //tạo biến truy xuất đến datatable
        var vDataRow = vTable.row(vRowSelected).data(); // lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
        console.log("User name: " + vDataRow.username);
        console.log("Firstname: " + vDataRow.firstname);
        console.log("Last name: " + vDataRow.lastname);
        console.log("Email: " + vDataRow.email);
        console.log("Age: " + vDataRow.age);
        console.log("Role: " + vDataRow.roleId);
      }
    });

    

  </script>
</body>

</html>